import { SelectQueryBuilder } from "typeorm";
import CommonHelper from "../helpers/common";
import { OrmHelper } from "../helpers/orm";
import { ItemTypeDetail } from "entity";

export class ItemTypeDetailModel {
    static async list(filter = {}): Promise<SelectQueryBuilder<any>> {
        const repo = OrmHelper.DB.getRepository(ItemTypeDetail);
        let whereAttr: string[] = [];
        let whereVal: any = {};
        if (filter && Object.keys(filter).length > 0) {
            whereAttr = [...whereAttr, ...CommonHelper.handleQueryFilter(filter, "item_type_detail").whereAttr];
            whereVal = { ...whereVal, ...CommonHelper.handleQueryFilter(filter, "item_type_detail").whereVal };
        }

        var query = repo.createQueryBuilder("item_type_detail").leftJoinAndSelect("item_type_detail.item_type", "item_type");
        if (whereAttr.length != 0) {
            query = query.where(whereAttr.join(" and "), whereVal);
        }

        return query;
    }
}